## samba4 4.0.0~alpha14~bzr13684.dfsg1

=== source4/wscript ===
#! /usr/bin/env python

srcdir = '..'
blddir = 'bin'

APPNAME='samba'
VERSION=None

import sys, os
sys.path.insert(0, srcdir+"/buildtools/wafsamba")
import wafsamba, Options, samba_dist, Scripting


def load_version(have_git=False):
    '''load samba versions either from ./VERSION or git
    return a version object for detailed breakdown'''
    import samba_utils, Utils
    if not have_git:
        env = samba_utils.LOAD_ENVIRONMENT()
        have_git = 'GIT' in env
    version = wafsamba.samba_version_file("./VERSION", have_git=have_git)
    Utils.g_module.VERSION = version.STRING
    return version


samba_dist.DIST_DIRS('.')

#This is a list of files that we don't want in the package, for
#whatever reason.  Directories should be listed with a trailing / to
#avoid over-exclusion.

#This list includes files that would confuse the recipient of a
#samba-4.0.0 branded tarball (until the merge is complete) and the
#core elements of the autotools build system (which is known to
#produce buggy binaries).
samba_dist.DIST_BLACKLIST('README Manifest Read-Manifest-Now Roadmap source3/ ' +
                          'packaging/ docs-xml/ examples/ swat/ WHATSNEW.txt MAINTAINERS ' +
                          'source4/autogen-autotools.sh source4/Makefile.in source4/configure.ac')
# install in /usr/local/samba by default
Options.default_prefix = '/usr/local/samba'


def set_options(opt):
    opt.BUILTIN_DEFAULT('replace')
    opt.BUNDLED_EXTENSION_DEFAULT('samba4')
    opt.RECURSE('../lib/replace')
    opt.RECURSE('dynconfig')
    opt.RECURSE('scripting/python')
    opt.RECURSE('lib/ldb')
    opt.RECURSE('selftest')
    opt.RECURSE('lib/tls')
    opt.RECURSE('../lib/nss_wrapper')
    opt.RECURSE('../lib/socket_wrapper')
    opt.RECURSE('../lib/uid_wrapper')
    opt.RECURSE('../pidl')

    gr = opt.option_group('developer options')
    gr.add_option('--enable-build-farm',
                   help='enable special build farm options',
                   action='store_true', dest='BUILD_FARM')


def configure(conf):
    version = load_version(have_git=True)

    conf.DEFINE('PACKAGE_NAME', 'samba', quote=True)
    conf.DEFINE('PACKAGE_STRING', 'Samba ' + version.STRING, quote=True)
    conf.DEFINE('PACKAGE_TARNAME',  'samba', quote=True)
    conf.DEFINE('PACKAGE_URL', "http://www.samba.org/", quote=True)
    conf.DEFINE('PACKAGE_VERSION', version.STRING, quote=True)
    conf.DEFINE('PACKAGE_BUGREPORT', 'http://bugzilla.samba.org/', quote=True)

    conf.DEFINE('CONFIG_H_IS_FROM_SAMBA', 1)
    conf.DEFINE('_SAMBA_BUILD_', version.MAJOR, add_to_cflags=True)
    conf.DEFINE('HAVE_CONFIG_H', 1, add_to_cflags=True)

    if Options.options.developer:
        conf.ADD_CFLAGS('-DDEVELOPER -DDEBUG_PASSWORD')

    # this enables smbtorture.static for s3 in the build farm
    conf.env.BUILD_FARM = Options.options.BUILD_FARM or os.environ.get('RUN_FROM_BUILD_FARM')

    # set a lower limit on recursing in waf preprocessor
    conf.env.preprocessor_recursion_limit = 10

    conf.ADD_EXTRA_INCLUDES('#source4 #lib #source4/lib #source4/include')

    conf.RECURSE('../lib/replace')

    conf.find_program('python', var='PYTHON', mandatory=True)
    conf.find_program('perl', var='PERL', mandatory=True)
    conf.find_program('xsltproc', var='XSLTPROC')

    # enable tool to build python extensions
    conf.check_tool('python')
    conf.check_python_version((2,4,2))
    conf.check_python_headers(mandatory=True)

    conf.RECURSE('dynconfig')
    conf.RECURSE('scripting/python')
    conf.RECURSE('lib/ldb')
    conf.RECURSE('heimdal_build')
    conf.RECURSE('lib/tls')
    conf.RECURSE('ntvfs/sysdep')
    conf.RECURSE('../lib/util')
    conf.RECURSE('../lib/zlib')
    conf.RECURSE('../lib/util/charset')
    conf.RECURSE('auth')
    conf.RECURSE('../lib/nss_wrapper')
    conf.RECURSE('../nsswitch')
    conf.RECURSE('../lib/socket_wrapper')
    conf.RECURSE('../lib/uid_wrapper')
    conf.RECURSE('../lib/popt')
    conf.RECURSE('../lib/subunit/c')
    conf.RECURSE('lib/smbreadline')
    conf.RECURSE('../pidl')
    conf.RECURSE('selftest')

    # we don't want PYTHONDIR in config.h, as otherwise changing
    # --prefix causes a complete rebuild
    del(conf.env.defines['PYTHONDIR'])
    conf.SAMBA_CONFIG_H('include/config.h')


def etags(ctx):
    '''build TAGS file using etags'''
    import Utils
    source_root = os.path.dirname(Utils.g_module.root_path)
    cmd = 'etags $(find %s/.. -name "*.[ch]")' % source_root
    print("Running: %s" % cmd)
    os.system(cmd)

def ctags(ctx):
    "build 'tags' file using ctags"
    import Utils
    source_root = os.path.dirname(Utils.g_module.root_path)
    cmd = 'ctags $(find %s/.. -name "*.[ch]" | grep -v "*_proto\.h")' % source_root
    print("Running: %s" % cmd)
    os.system(cmd)

# putting this here enabled build in the list
# of commands in --help
def build(bld):
    '''build all targets'''
    load_version()
    pass


def pydoctor(ctx):
    '''build python apidocs'''
    cmd='LD_LIBRARY_PATH=bin/shared PYTHONPATH=bin/python pydoctor --project-name=Samba --project-url=http://www.samba.org --make-html --docformat=restructuredtext --add-package bin/python/samba'
    print("Running: %s" % cmd)
    os.system(cmd)

def wafdocs(ctx):
    '''build wafsamba apidocs'''
    from samba_utils import recursive_dirlist
    os.system('pwd')
    list = recursive_dirlist('../buildtools/wafsamba', '.', pattern='*.py')

    cmd='LD_LIBRARY_PATH=bin/shared PYTHONPATH=bin/python pydoctor --project-name=wafsamba --project-url=http://www.samba.org --make-html --docformat=restructuredtext'
    print(list)
    for f in list:
        cmd += ' --add-module %s' % f
    print("Running: %s" % cmd)
    os.system(cmd)


def dist():
    '''makes a tarball for distribution'''
    load_version()
    samba_dist.dist()

def distcheck():
    '''test that distribution tarball builds and installs'''
    load_version()
    import Scripting
    d = Scripting.distcheck
    d(subdir='source4')

def wildcard_cmd(cmd):
    '''called on a unknown command'''
    from samba_wildcard import run_named_build_task
    run_named_build_task(cmd)

def main():
    from samba_wildcard import wildcard_main
    wildcard_main(wildcard_cmd)
Scripting.main = main

def reconfigure(ctx):
    '''reconfigure if config scripts have changed'''
    import samba_utils
    samba_utils.reconfigure(ctx)

=== buildtools/wafsamba/wscript ===
#!/usr/bin/env python

# this is a base set of waf rules that everything else pulls in first

import sys, wafsamba, Configure
import Options, os, preproc
from samba_utils import *
from optparse import SUPPRESS_HELP

# this forces configure to be re-run if any of the configure
# sections of the build scripts change. We have to check
# for this in sys.argv as options have not yet been parsed when
# we need to set this. This is off by default until some issues
# are resolved related to WAFCACHE. It will need a lot of testing
# before it is enabled by default.
if '--enable-auto-reconfigure' in sys.argv:
    Configure.autoconfig = True

def set_options(opt):
    opt.tool_options('compiler_cc')

    opt.tool_options('gnu_dirs')

    gr = opt.option_group('library handling options')

    gr.add_option('--bundled-libraries',
                   help=("comma separated list of bundled libraries. May include !LIBNAME to disable bundling a library. Can be 'NONE' or 'ALL' [auto]"),
                   action="store", dest='BUNDLED_LIBS', default='')

    extension_default = Options.options['BUNDLED_EXTENSION_DEFAULT']
    gr.add_option('--bundled-library-extension',
                   help=("name extension for bundled libraries [%s]" % extension_default),
                   action="store", dest='BUNDLED_EXTENSION', default=extension_default)

    extension_exception = Options.options['BUNDLED_EXTENSION_EXCEPTION']
    gr.add_option('--bundled-extension-exception',
                   help=("comman separated list of libraries to not apply extension to [%s]" % extension_exception),
                   action="store", dest='BUNDLED_EXTENSION_EXCEPTION', default=extension_exception)

    builtin_defauilt = Options.options['BUILTIN_LIBRARIES_DEFAULT']
    gr.add_option('--builtin-libraries',
                   help=("command separated list of libraries to build directly into binaries [%s]" % builtin_defauilt),
                   action="store", dest='BUILTIN_LIBRARIES', default=builtin_defauilt)

    gr.add_option('--minimum-library-version',
                   help=("list of minimum system library versions (LIBNAME1:version,LIBNAME2:version)"),
                   action="store", dest='MINIMUM_LIBRARY_VERSION', default='')

    gr.add_option('--disable-shared',
                   help=("Disable all use of shared libraries"),
                   action="store_true", dest='disable_shared', default=False)
    gr.add_option('--disable-rpath',
                   help=("Disable use of rpath for build binaries"),
                   action="store_true", dest='disable_rpath_build', default=False)
    gr.add_option('--disable-rpath-install',
                   help=("Disable use of rpath for installed binaries"),
                   action="store_true", dest='disable_rpath_install', default=False)
    gr.add_option('--nonshared-binary',
                   help=("Disable use of shared libs for the listed binaries"),
                   action="store", dest='NONSHARED_BINARIES', default='')

    opt.add_option('--with-modulesdir',
                   help=("modules directory [PREFIX/modules]"),
                   action="store", dest='MODULESDIR', default='${PREFIX}/modules')

    gr = opt.option_group('developer options')

    gr.add_option('-C',
                   help='enable configure cacheing',
                   action='store_true', dest='enable_configure_cache')
    gr.add_option('--enable-auto-reconfigure',
                   help='enable automatic reconfigure on build',
                   action='store_true', dest='enable_auto_reconfigure')
    gr.add_option('--enable-developer',
                   help=("Turn on developer warnings and debugging"),
                   action="store_true", dest='developer', default=False)
    gr.add_option('--picky-developer',
                   help=("Treat all warnings as errors (enable -Werror)"),
                   action="store_true", dest='picky_developer', default=False)
    gr.add_option('--fatal-errors',
                   help=("Stop compilation on first error (enable -Wfatal-errors)"),
                   action="store_true", dest='fatal_errors', default=False)
    gr.add_option('--enable-gccdeps',
                   help=("Enable use of gcc -MD dependency module"),
                   action="store_true", dest='enable_gccdeps', default=True)
    gr.add_option('--timestamp-dependencies',
                   help=("use file timestamps instead of content for build dependencies (BROKEN)"),
                   action="store_true", dest='timestamp_dependencies', default=False)
    gr.add_option('--pedantic',
		   help=("Enable even more compiler warnings"),
		   action='store_true', dest='pedantic', default=False)

    gr.add_option('--abi-check',
		   help=("Check ABI signatures for libraries"),
		   action='store_true', dest='ABI_CHECK', default=False)
    gr.add_option('--abi-check-disable',
		   help=("Disable ABI checking (used with --enable-developer)"),
		   action='store_true', dest='ABI_CHECK_DISABLE', default=False)
    gr.add_option('--abi-update',
		   help=("Update ABI signature files for libraries"),
		   action='store_true', dest='ABI_UPDATE', default=False)

    gr = opt.add_option_group('cross compilation options')

    gr.add_option('--cross-compile',
		   help=("configure for cross-compilation"),
		   action='store_true', dest='CROSS_COMPILE', default=False)
    gr.add_option('--cross-execute',
		   help=("command prefix to use for cross-execution in configure"),
		   action='store', dest='CROSS_EXECUTE', default='')
    gr.add_option('--cross-answers',
		   help=("answers to cross-compilation configuration (auto modified)"),
		   action='store', dest='CROSS_ANSWERS', default='')
    gr.add_option('--hostcc',
		   help=("set host compiler when cross compiling"),
		   action='store', dest='HOSTCC', default=False)

    # we use SUPPRESS_HELP for these, as they are ignored, and are there only
    # to allow existing RPM spec files to work
    opt.add_option('--build',
		   help=SUPPRESS_HELP,
		   action='store', dest='AUTOCONF_BUILD', default='')
    opt.add_option('--host',
		   help=SUPPRESS_HELP,
		   action='store', dest='AUTOCONF_HOST', default='')
    opt.add_option('--program-prefix',
		   help=SUPPRESS_HELP,
		   action='store', dest='AUTOCONF_PROGRAM_PREFIX', default='')
    opt.add_option('--disable-dependency-tracking',
		   help=SUPPRESS_HELP,
		   action='store_true', dest='AUTOCONF_DISABLE_DEPENDENCY_TRACKING', default=False)

    gr = opt.option_group('dist options')
    gr.add_option('--sign-release',
                   help='sign the release tarball created by waf dist',
                   action='store_true', dest='SIGN_RELEASE')
    gr.add_option('--tag',
                   help='tag release in git at the same time',
                   type='string', action='store', dest='TAG_RELEASE')


@wafsamba.runonce
def configure(conf):
    conf.env.hlist = []
    conf.env.srcdir = conf.srcdir

    if Options.options.timestamp_dependencies:
        conf.ENABLE_TIMESTAMP_DEPENDENCIES()

    conf.SETUP_CONFIGURE_CACHE(Options.options.enable_configure_cache)

    # load our local waf extensions
    conf.check_tool('gnu_dirs')
    conf.check_tool('wafsamba')

    conf.CHECK_CC_ENV()

    conf.check_tool('compiler_cc')

    # we need git for 'waf dist'
    conf.find_program('git', var='GIT')

    # older gcc versions (< 4.4) does not work with gccdeps, so we have to see if the .d file is generated
    if Options.options.enable_gccdeps:
        from TaskGen import feature, after
        @feature('testd')
        @after('apply_core')
        def check_d(self):
            tsk = self.compiled_tasks[0]
            tsk.outputs.append(tsk.outputs[0].change_ext('.d'))

        import Task
        cc = Task.TaskBase.classes['cc']
        oldmeth = cc.run

        cc.run = Task.compile_fun_noshell('cc', '${CC} ${CCFLAGS} ${CPPFLAGS} ${_CCINCFLAGS} ${_CCDEFFLAGS} ${CC_SRC_F}${SRC} ${CC_TGT_F}${TGT[0].abspath(env)}')[0]
        try:
            try:
                conf.check(features='cc testd', fragment='int main() {return 0;}\n', ccflags=['-MD'], mandatory=True, msg='Check for -MD')
            except:
                pass
            else:
                conf.check_tool('gccdeps', tooldir=conf.srcdir + "/buildtools/wafsamba")
        finally:
            cc.run = oldmeth

    # make the install paths available in environment
    conf.env.LIBDIR = Options.options.LIBDIR or '${PREFIX}/lib'
    conf.env.BINDIR = Options.options.BINDIR or '${PREFIX}/bin'
    conf.env.SBINDIR = Options.options.SBINDIR or '${PREFIX}/sbin'
    conf.env.MODULESDIR = Options.options.MODULESDIR
    conf.env.BUNDLED_LIBS = Options.options.BUNDLED_LIBS.split(',')
    conf.env.BUILTIN_LIBRARIES = Options.options.BUILTIN_LIBRARIES.split(',')
    conf.env.DISABLE_SHARED = Options.options.disable_shared
    conf.env.NONSHARED_BINARIES = Options.options.NONSHARED_BINARIES.split(',')

    conf.env.BUNDLED_EXTENSION = Options.options.BUNDLED_EXTENSION
    conf.env.BUNDLED_EXTENSION_EXCEPTION = Options.options.BUNDLED_EXTENSION_EXCEPTION.split(',')

    conf.env.CROSS_COMPILE = Options.options.CROSS_COMPILE
    conf.env.CROSS_EXECUTE = Options.options.CROSS_EXECUTE
    conf.env.CROSS_ANSWERS = Options.options.CROSS_ANSWERS
    conf.env.HOSTCC        = Options.options.HOSTCC

    conf.env.AUTOCONF_BUILD = Options.options.AUTOCONF_BUILD
    conf.env.AUTOCONF_HOST  = Options.options.AUTOCONF_HOST
    conf.env.AUTOCONF_PROGRAM_PREFIX = Options.options.AUTOCONF_PROGRAM_PREFIX

    if (conf.env.AUTOCONF_HOST and
        conf.env.AUTOCONF_BUILD and
        conf.env.AUTOCONF_BUILD != conf.env.AUTOCONF_HOST):
        Logs.error('ERROR: Mismatch between --build and --host. Please use --cross-compile instead')
        sys.exit(1)
    if conf.env.AUTOCONF_PROGRAM_PREFIX:
        Logs.error('ERROR: --program-prefix not supported')
        sys.exit(1)

    # enable ABI checking for developers
    conf.env.ABI_CHECK = Options.options.ABI_CHECK or Options.options.developer
    if Options.options.ABI_CHECK_DISABLE:
        conf.env.ABI_CHECK = False
    try:
        conf.find_program('gdb', mandatory=True)
    except:
        conf.env.ABI_CHECK = False

    conf.CHECK_COMMAND(['uname', '-a'],
                       msg='Checking build system',
                       define='BUILD_SYSTEM',
                       on_target=False)
    conf.CHECK_UNAME()

    # see if we can compile and run a simple C program
    conf.CHECK_CODE('printf("hello world")',
                    define='HAVE_SIMPLE_C_PROG',
                    mandatory=True,
                    execute=True,
                    headers='stdio.h',
                    msg='Checking simple C program')

    # see if we can build shared libs
    if not conf.CHECK_LIBRARY_SUPPORT():
        conf.env.DISABLE_SHARED = True

    # check for rpath
    if not conf.env.DISABLE_SHARED and conf.CHECK_LIBRARY_SUPPORT(rpath=True):
        conf.env.RPATH_ON_BUILD   = not Options.options.disable_rpath_build
        conf.env.RPATH_ON_INSTALL = (conf.env.RPATH_ON_BUILD and
                                     not Options.options.disable_rpath_install)
    else:
        conf.env.RPATH_ON_INSTALL = False
        conf.env.RPATH_ON_BUILD   = False

    # we should use the PIC options in waf instead
    conf.ADD_CFLAGS('-fPIC', testflags=True)

    conf.CHECK_INLINE()

    # check for pkgconfig
    conf.check_cfg(atleast_pkgconfig_version='0.0.0')

    conf.DEFINE('_GNU_SOURCE', 1, add_to_cflags=True)
    conf.DEFINE('_XOPEN_SOURCE_EXTENDED', 1, add_to_cflags=True)

    # get the base headers we'll use for the rest of the tests
    conf.CHECK_HEADERS('stdio.h sys/types.h sys/stat.h stdlib.h stddef.h memory.h string.h',
                       add_headers=True)
    conf.CHECK_HEADERS('strings.h inttypes.h stdint.h unistd.h minix/config.h', add_headers=True)
    conf.CHECK_HEADERS('ctype.h standards.h stdbool.h stdint.h stdarg.h vararg.h', add_headers=True)

=== lib/popt/wscript ===
#!/usr/bin/env python

import Options

def configure(conf):
    conf.CHECK_HEADERS('float.h')

    if conf.CHECK_BUNDLED_SYSTEM('popt', checkfunctions='poptGetContext', headers='popt.h'):
        conf.define('USING_SYSTEM_POPT', 1)

def build(bld):
    if bld.CONFIG_SET('USING_SYSTEM_POPT'):
        return

    bld.SAMBA_LIBRARY('popt',
                      source='findme.c popt.c poptconfig.c popthelp.c poptparse.c',
                      cflags='-DDBL_EPSILON=__DBL_EPSILON__',
					  is_bundled=True,
                      )

=== lib/replace/wscript ===
#!/usr/bin/env python

APPNAME = 'libreplace'
VERSION = '1.2.1'

blddir = 'bin'

import sys, os, Utils

# find the buildtools directory
srcdir = '.'
while not os.path.exists(srcdir+'/buildtools') and len(srcdir.split('/')) < 5:
    srcdir = '../' + srcdir
sys.path.insert(0, srcdir + '/buildtools/wafsamba')

import wafsamba, samba_dist
import Options, os, preproc

samba_dist.DIST_DIRS('lib/replace buildtools:buildtools')

def set_options(opt):
    opt.BUILTIN_DEFAULT('NONE')
    opt.BUNDLED_EXTENSION_DEFAULT('')
    opt.RECURSE('buildtools/wafsamba')

@wafsamba.runonce
def configure(conf):
    conf.RECURSE('buildtools/wafsamba')

    conf.DEFINE('LIBREPLACE_NETWORK_CHECKS', 1)

    # on Tru64 certain features are only available with _OSF_SOURCE set to 1
    # and _XOPEN_SOURCE set to 600
    if conf.env['SYSTEM_UNAME_SYSNAME'] == 'OSF1':
        conf.DEFINE('_OSF_SOURCE', 1, add_to_cflags=True)
        conf.DEFINE('_XOPEN_SOURCE', 600, add_to_cflags=True)

    conf.CHECK_HEADERS('crypt.h locale.h acl/libacl.h compat.h')
    conf.CHECK_HEADERS('acl/libacl.h attr/xattr.h compat.h ctype.h dustat.h')
    conf.CHECK_HEADERS('fcntl.h fnmatch.h glob.h history.h krb5.h langinfo.h')
    conf.CHECK_HEADERS('libaio.h locale.h ndir.h pwd.h')
    conf.CHECK_HEADERS('shadow.h sys/acl.h')
    conf.CHECK_HEADERS('sys/attributes.h sys/capability.h sys/dir.h sys/epoll.h')
    conf.CHECK_HEADERS('sys/fcntl.h sys/filio.h sys/filsys.h sys/fs/s5param.h sys/fs/vx/quota.h')
    conf.CHECK_HEADERS('sys/id.h sys/ioctl.h sys/ipc.h sys/mman.h sys/mode.h sys/ndir.h sys/priv.h')
    conf.CHECK_HEADERS('sys/resource.h sys/security.h sys/shm.h sys/statfs.h sys/statvfs.h sys/termio.h')
    conf.CHECK_HEADERS('sys/vfs.h sys/xattr.h termio.h termios.h sys/file.h')
    conf.CHECK_HEADERS('sys/wait.h sys/stat.h malloc.h grp.h')
    conf.CHECK_HEADERS('sys/select.h setjmp.h utime.h sys/syslog.h syslog.h')
    conf.CHECK_HEADERS('stdarg.h vararg.h sys/mount.h mntent.h')
    conf.CHECK_HEADERS('stropts.h unix.h string.h strings.h sys/param.h limits.h')
    conf.CHECK_HEADERS('''sys/socket.h netinet/in.h netdb.h arpa/inet.h netinet/in_systm.h
                          netinet/ip.h netinet/tcp.h netinet/in_ip.h
                          sys/sockio.h sys/un.h''', together=True)
    conf.CHECK_HEADERS('sys/uio.h ifaddrs.h direct.h dirent.h')
    conf.CHECK_HEADERS('windows.h winsock2.h ws2tcpip.h')
    conf.CHECK_HEADERS('libintl.h errno.h')
    conf.CHECK_HEADERS('gcrypt.h getopt.h iconv.h')
    conf.CHECK_HEADERS('sys/inotify.h memory.h nss.h sasl/sasl.h')
    conf.CHECK_HEADERS('security/pam_appl.h sys/inotify.h zlib.h asm/unistd.h')
    conf.CHECK_HEADERS('aio.h sys/unistd.h rpc/rpc.h rpc/nettype.h alloca.h float.h')

    conf.CHECK_HEADERS('rpcsvc/nis.h rpcsvc/ypclnt.h sys/prctl.h sys/sysctl.h')
    conf.CHECK_HEADERS('sys/fileio.h sys/filesys.h sys/dustat.h sys/sysmacros.h')
    conf.CHECK_HEADERS('xfs/libxfs.h netgroup.h rpcsvc/yp_prot.h')
    conf.CHECK_HEADERS('valgrind.h valgrind/valgrind.h valgrind/memcheck.h')
    conf.CHECK_HEADERS('nss_common.h nsswitch.h ns_api.h')
    conf.CHECK_HEADERS('sys/extattr.h sys/ea.h sys/proplist.h sys/cdefs.h')
    conf.CHECK_HEADERS('utmp.h utmpx.h lastlog.h')
    conf.CHECK_HEADERS('syscall.h sys/syscall.h inttypes.h')

    conf.CHECK_TYPES('"long long" intptr_t uintptr_t ptrdiff_t comparison_fn_t')
    conf.CHECK_TYPE('_Bool', define='HAVE__Bool')

    conf.CHECK_TYPE('int8_t', 'char')
    conf.CHECK_TYPE('int16_t', 'short')
    conf.CHECK_TYPE('uint16_t', 'unsigned short')
    conf.CHECK_TYPE('int32_t', 'int')
    conf.CHECK_TYPE('uint32_t', 'unsigned')
    conf.CHECK_TYPE('int64_t', 'long long')
    conf.CHECK_TYPE('uint64_t', 'unsigned long long')
    conf.CHECK_TYPE('size_t', 'unsigned int')
    conf.CHECK_TYPE('ssize_t', 'int')
    conf.CHECK_TYPE('ino_t', 'unsigned')
    conf.CHECK_TYPE('loff_t', 'off_t')
    conf.CHECK_TYPE('bool', 'off_t')
    conf.CHECK_TYPE('offset_t', 'loff_t')
    conf.CHECK_TYPE('volatile int', define='HAVE_VOLATILE')
    conf.CHECK_TYPE('uint_t', 'unsigned int')

    conf.CHECK_TYPES('socklen_t', headers='sys/socket.h')
    conf.CHECK_TYPE_IN('struct ifaddrs', 'ifaddrs.h')
    conf.CHECK_TYPE_IN('struct addrinfo', 'netdb.h')
    conf.CHECK_TYPE_IN('struct sockaddr', 'sys/socket.h')
    conf.CHECK_CODE('struct sockaddr_in6 x', define='HAVE_STRUCT_SOCKADDR_IN6',
                    headers='sys/socket.h netdb.h netinet/in.h')
    conf.CHECK_TYPE_IN('struct sockaddr_storage', 'sys/socket.h')
    conf.CHECK_TYPE_IN('sa_family_t', 'sys/socket.h')

    conf.CHECK_TYPE_IN('sig_atomic_t', 'signal.h', define='HAVE_SIG_ATOMIC_T_TYPE')

    conf.CHECK_FUNCS_IN('''inet_ntoa inet_aton inet_ntop inet_pton connect gethostbyname
                           getaddrinfo getnameinfo freeaddrinfo gai_strerror socketpair''',
                        'socket nsl', checklibc=True,
                        headers='sys/socket.h netinet/in.h arpa/inet.h netdb.h')

    # Some old Linux systems have broken header files and
    # miss the IPV6_V6ONLY define in netinet/in.h,
    # but have it in linux/in6.h.
    # We can't include both files so we just check if the value
    # if defined and do the replacement in system/network.h
    if not conf.CHECK_VARIABLE('IPV6_V6ONLY',
                               headers='sys/socket.h netdb.h netinet/in.h'):
        conf.CHECK_CODE('''
                        #include <linux/in6.h>
                        #if (IPV6_V6ONLY != 26)
                        #error no IPV6_V6ONLY support on linux
                        #endif
                        int main(void) { return IPV6_V6ONLY; }
                        ''',
                        define='HAVE_LINUX_IPV6_V6ONLY_26',
                        addmain=False,
                        msg='Checking for IPV6_V6ONLY in linux/in6.h',
                        local_include=False)

    conf.CHECK_CODE('''
                       struct sockaddr_storage sa_store;
                       struct addrinfo *ai = NULL;
                       struct in6_addr in6addr;
                       int idx = if_nametoindex("iface1");
                       int s = socket(AF_INET6, SOCK_STREAM, 0);
                       int ret = getaddrinfo(NULL, NULL, NULL, &ai);
                       if (ret != 0) {
			  const char *es = gai_strerror(ret);
                       }
                       freeaddrinfo(ai);
                       {
                          int val = 1;
                          #ifdef HAVE_LINUX_IPV6_V6ONLY_26
                          #define IPV6_V6ONLY 26
                          #endif
                          ret = setsockopt(s, IPPROTO_IPV6, IPV6_V6ONLY,
                                           (const void *)&val, sizeof(val));
                       }
                       ''',
                    define='HAVE_IPV6',
                    lib='nsl socket',
                    headers='sys/socket.h netdb.h netinet/in.h')

    # these may be builtins, so we need the link=False strategy
    conf.CHECK_FUNCS('strdup memmem printf memset memcpy memmove strcpy strncpy bzero', link=False)

    conf.CHECK_FUNCS('shl_load shl_unload shl_findsym')
    conf.CHECK_FUNCS('pipe strftime srandom random srand rand usleep setbuffer')
    conf.CHECK_FUNCS('lstat getpgrp utime utimes seteuid setresuid setegid')
    conf.CHECK_FUNCS('setresgid chroot strerror vsyslog setlinebuf mktime')
    conf.CHECK_FUNCS('ftruncate chsize rename waitpid wait4 strlcpy strlcat')
    conf.CHECK_FUNCS('initgroups pread pwrite strndup strcasestr')
    conf.CHECK_FUNCS('strtok_r mkdtemp dup2 dprintf vdprintf isatty chown lchown')
    conf.CHECK_FUNCS('link readlink symlink realpath snprintf vsnprintf')
    conf.CHECK_FUNCS('asprintf vasprintf setenv unsetenv strnlen strtoull __strtoull')
    conf.CHECK_FUNCS('strtouq strtoll __strtoll strtoq')
    conf.CHECK_FUNCS('if_nametoindex strerror_r')
    conf.CHECK_FUNCS('getdirentries getdents syslog')
    conf.CHECK_FUNCS('gai_strerror get_current_dir_name')
    conf.CHECK_FUNCS('timegm getifaddrs freeifaddrs mmap setgroups setsid')
    conf.CHECK_FUNCS('getgrent_r getgrgid_r getgrnam_r getgrouplist getpagesize')
    conf.CHECK_FUNCS('getpwent_r getpwnam_r getpwuid_r epoll_create')

    conf.CHECK_FUNCS_IN('dlopen dlsym dlerror dlclose', 'dl',
                        checklibc=True, headers='dlfcn.h dl.h')

    conf.CHECK_C_PROTOTYPE('dlopen', 'void *dlopen(const char* filename, unsigned int flags)',
                           define='DLOPEN_TAKES_UNSIGNED_FLAGS', headers='dlfcn.h dl.h')

    conf.CHECK_FUNCS_IN('fdatasync', 'rt', checklibc=True)
    conf.CHECK_FUNCS_IN('clock_gettime', 'rt', checklibc=True)

    # these headers need to be tested as a group on freebsd
    conf.CHECK_HEADERS(headers='sys/socket.h net/if.h', together=True)
    conf.CHECK_HEADERS(headers='netinet/in.h arpa/nameser.h resolv.h', together=True)
    conf.CHECK_FUNCS_IN('res_search', 'resolv', checklibc=True,
                        headers='netinet/in.h arpa/nameser.h resolv.h')

    conf.CHECK_FUNCS_IN('gettext', 'intl', checklibc=True, headers='libintl.h')
    conf.CHECK_FUNCS_IN('pthread_create', 'pthread', checklibc=True, headers='pthread.h')

    conf.CHECK_FUNCS_IN('crypt', 'crypt', checklibc=True)

    conf.CHECK_VARIABLE('rl_event_hook', define='HAVE_DECL_RL_EVENT_HOOK', always=True,
                        headers='readline.h readline/readline.h readline/history.h')

    conf.CHECK_DECLS('snprintf vsnprintf asprintf vasprintf')

    conf.CHECK_DECLS('errno', headers='errno.h', reverse=True)
    conf.CHECK_DECLS('environ getgrent_r getpwent_r', reverse=True, headers='pwd.h grp.h')
    conf.CHECK_DECLS('pread pwrite setenv setresgid setresuid', reverse=True)

    conf.CHECK_SIZEOF('char int "long long" long off_t short size_t ssize_t')
    conf.CHECK_SIZEOF('dev_t ino_t time_t')
    conf.CHECK_SIZEOF('void*', define='SIZEOF_VOID_P')

    if conf.CONFIG_SET('HAVE_EPOLL_CREATE') and conf.CONFIG_SET('HAVE_SYS_EPOLL_H'):
        conf.DEFINE('HAVE_EPOLL', 1)

    if not conf.CHECK_CODE('''#define LIBREPLACE_CONFIGURE_TEST_STRPTIME
		       #include "test/strptime.c"''',
                           define='HAVE_STRPTIME',
                           addmain=False,
                           msg='Checking for working strptime'):
        conf.DEFINE('REPLACE_STRPTIME', 1)

    if conf.CONFIG_SET('HAVE_KRB5_H'):
        # Check for KRB5_DEPRECATED handling
        conf.CHECK_CODE('''#define KRB5_DEPRECATED 1
#include <krb5.h>''',
                        'HAVE_KRB5_DEPRECATED_WITH_IDENTIFIER', addmain=False,
                        link=False,
                        msg="Checking for KRB5_DEPRECATED define taking an identifier")

    conf.CHECK_CODE('gettimeofday(NULL, NULL)', 'HAVE_GETTIMEOFDAY_TZ', execute=False)

    conf.CHECK_CODE('#include "test/snprintf.c"',
                    define="HAVE_C99_VSNPRINTF",
                    execute=1,
                    addmain=False,
                    msg="Checking for C99 vsnprintf")

    conf.SAMBA_BUILD_ENV()

    conf.CHECK_CODE('''
		    typedef struct {unsigned x;} FOOBAR;
                    #define X_FOOBAR(x) ((FOOBAR) { x })
                    #define FOO_ONE X_FOOBAR(1)
                    FOOBAR f = FOO_ONE;
                    static const struct {
                        FOOBAR y;
                    } f2[] = {
                        {FOO_ONE}
                    };
                    static const FOOBAR f3[] = {FOO_ONE};
                    ''',
                    define='HAVE_IMMEDIATE_STRUCTURES')

    conf.CHECK_CODE('mkdir("foo",0777)', define='HAVE_MKDIR_MODE', headers='sys/stat.h')

    conf.CHECK_STRUCTURE_MEMBER('struct stat', 'st_mtim.tv_nsec', define='HAVE_STAT_TV_NSEC',
                                headers='sys/stat.h')
    # we need the st_rdev test under two names
    conf.CHECK_STRUCTURE_MEMBER('struct stat', 'st_rdev',
                                define='HAVE_STRUCT_STAT_ST_RDEV',

=== lib/socket_wrapper/wscript ===
#!/usr/bin/env python

import Options

def set_options(opt):
	gr = opt.option_group('developer options')
        gr.add_option('--enable-socket-wrapper',
                   help=("Turn on socket wrapper library (default=no)"),
                   action="store_true", dest='enable_socket_wrapper', default=False)

def configure(conf):
    if (Options.options.enable_socket_wrapper or Options.options.developer or Options.options.enable_selftest):
        conf.DEFINE('SOCKET_WRAPPER', 1)
    conf.ADD_GLOBAL_DEPENDENCY('SOCKET_WRAPPER')

=== lib/talloc/wscript ===
#!/usr/bin/env python

APPNAME = 'talloc'
VERSION = '2.0.3'


blddir = 'bin'

import os, sys

# find the buildtools directory
srcdir = '.'
while not os.path.exists(srcdir+'/buildtools') and len(srcdir.split('/')) < 5:
    srcdir = '../' + srcdir
sys.path.insert(0, srcdir + '/buildtools/wafsamba')

import sys
sys.path.insert(0, srcdir+"/buildtools/wafsamba")
import wafsamba, samba_dist, Options

# setup what directories to put in a tarball
samba_dist.DIST_DIRS('lib/talloc:. lib/replace:lib/replace buildtools:buildtools')


def set_options(opt):
    opt.BUILTIN_DEFAULT('replace')
    opt.BUNDLED_EXTENSION_DEFAULT('talloc', noextension='talloc')
    opt.RECURSE('lib/replace')
    opt.add_option('--enable-talloc-compat1',
                   help=("Build talloc 1.x.x compat library [False]"),
                   action="store_true", dest='TALLOC_COMPAT1', default=False)

def configure(conf):
    conf.RECURSE('lib/replace')

    conf.env.standalone_talloc = conf.IN_LAUNCH_DIR()

    if not conf.env.standalone_talloc:
        if conf.CHECK_BUNDLED_SYSTEM('talloc', minversion=VERSION,
                                     implied_deps='replace'):
            conf.define('USING_SYSTEM_TALLOC', 1)

    conf.env.TALLOC_COMPAT1 = Options.options.TALLOC_COMPAT1

    if conf.env.standalone_talloc:
        conf.find_program('xsltproc', var='XSLTPROC')

    conf.SAMBA_CONFIG_H()



def build(bld):
    bld.RECURSE('lib/replace')

    if not bld.CONFIG_SET('USING_SYSTEM_TALLOC'):

        bld.SAMBA_LIBRARY('talloc',
                          'talloc.c',
                          deps='replace',
                          abi_file='ABI/talloc-%s.sigs' % VERSION,
                          abi_match='talloc* _talloc*',
                          hide_symbols=True,
                          vnum=VERSION,
						  is_bundled=not bld.env.standalone_talloc, 
						  manpages='talloc.3')

        # should we also install the symlink to libtalloc1.so here?
        bld.SAMBA_LIBRARY('talloc-compat1',
                          'compat/talloc_compat1.c',
                          deps='talloc',
                          enabled = bld.env.TALLOC_COMPAT1,
                          vnum=VERSION,
						  is_bundled=not bld.env.standalone_talloc)

    if not getattr(bld.env, '_SAMBA_BUILD_', 0) == 4:
        # s4 already has the talloc testsuite builtin to smbtorture
        bld.SAMBA_BINARY('talloc_testsuite',
                         'testsuite_main.c testsuite.c',
                         deps='talloc',
                         install=False)

    if bld.env.standalone_talloc:
        bld.env.PKGCONFIGDIR = '${LIBDIR}/pkgconfig'
        bld.env.TALLOC_VERSION = VERSION
        bld.PKG_CONFIG_FILES('talloc.pc', vnum=VERSION)
        bld.INSTALL_FILES('${INCLUDEDIR}', 'talloc.h')

def test(ctx):
    '''run talloc testsuite'''
    import Utils
    cmd = os.path.join(Utils.g_module.blddir, 'talloc_testsuite')
    os.system(cmd)

def dist():
    '''makes a tarball for distribution'''
    samba_dist.dist()

=== lib/tdb/wscript ===
#!/usr/bin/env python

APPNAME = 'tdb'
VERSION = '1.2.6'

blddir = 'bin'

import sys, os

# find the buildtools directory
srcdir = '.'
while not os.path.exists(srcdir+'/buildtools') and len(srcdir.split('/')) < 5:
    srcdir = '../' + srcdir
sys.path.insert(0, srcdir + '/buildtools/wafsamba')

import wafsamba, samba_dist, Options, Logs

samba_dist.DIST_DIRS('lib/tdb:. lib/replace:lib/replace buildtools:buildtools')

def set_options(opt):
    opt.BUILTIN_DEFAULT('replace')
    opt.BUNDLED_EXTENSION_DEFAULT('tdb', noextension='tdb')
    opt.RECURSE('lib/replace')
    if opt.IN_LAUNCH_DIR():
        opt.add_option('--disable-python',
                       help=("disable the pytdb module"),
                       action="store_true", dest='disable_python', default=False)


def configure(conf):
    conf.RECURSE('lib/replace')

    conf.env.standalone_tdb = conf.IN_LAUNCH_DIR()

    if not conf.env.standalone_tdb:
        if conf.CHECK_BUNDLED_SYSTEM('tdb', minversion=VERSION,
                                     implied_deps='replace'):
            conf.define('USING_SYSTEM_TDB', 1)

    conf.env.disable_python = getattr(Options.options, 'disable_python', False)

    conf.CHECK_XSLTPROC_MANPAGES()

    if not conf.env.disable_python:
        # also disable if we don't have the python libs installed
        conf.check_tool('python')
        conf.check_python_version((2,4,2))
        conf.check_python_headers(mandatory=False)
        if not conf.env.HAVE_PYTHON_H:
            Logs.warn('Disabling pytdb as python devel libs not found')
            conf.env.disable_python = True

    conf.SAMBA_CONFIG_H()

def build(bld):
    bld.RECURSE('lib/replace')

    COMMON_SRC = bld.SUBDIR('common',
                            '''check.c error.c tdb.c traverse.c
                            freelistcheck.c lock.c dump.c freelist.c
                            io.c open.c transaction.c hash.c''')

    if not bld.CONFIG_SET('USING_SYSTEM_TDB'):
        bld.SAMBA_LIBRARY('tdb',
                          COMMON_SRC,
                          deps='replace',
                          includes='include',
                          abi_file='ABI/tdb-%s.sigs' % VERSION,
                          abi_match='tdb_*',
                          hide_symbols=True,
                          vnum=VERSION, is_bundled=not bld.env.standalone_tdb)

        bld.SAMBA_BINARY('tdbtorture',
                         'tools/tdbtorture.c',
                         'tdb',
                         install=False)

        bld.SAMBA_BINARY('tdbrestore',
                         'tools/tdbrestore.c',
                         'tdb', manpages='manpages/tdbrestore.8')

        bld.SAMBA_BINARY('tdbdump',
                         'tools/tdbdump.c',
                         'tdb', manpages='manpages/tdbdump.8')

        bld.SAMBA_BINARY('tdbbackup',
                         'tools/tdbbackup.c',
                         'tdb',
                         manpages='manpages/tdbbackup.8')

        bld.SAMBA_BINARY('tdbtool',
                         'tools/tdbtool.c',
                         'tdb', manpages='manpages/tdbtool.8')

    s4_build = getattr(bld.env, '_SAMBA_BUILD_', 0) == 4

    bld.SAMBA_PYTHON('pytdb',
                     'pytdb.c',
                     deps='tdb',
                     enabled=not bld.env.disable_python,
                     realname='tdb.so')

    if bld.env.standalone_tdb:
        bld.env.PKGCONFIGDIR = '${LIBDIR}/pkgconfig'
        bld.PKG_CONFIG_FILES('tdb.pc', vnum=VERSION)
        bld.INSTALL_FILES('${INCLUDEDIR}', 'include/tdb.h', flat=True)


def test(ctx):
    '''run tdb testsuite'''
    import Utils
    cmd = os.path.join(Utils.g_module.blddir, 'tdbtorture')
    os.system(cmd)

def dist():
    '''makes a tarball for distribution'''
    samba_dist.dist()

=== lib/tevent/Makefile ===
# simple makefile wrapper to run waf

WAFPATH:=$(shell PATH=../../buildtools/bin:buildtools/bin:$(PATH) which waf)

WAF=WAF_MAKE=1 $(WAFPATH)

all:
	$(WAF) build

install:
	$(WAF) install

uninstall:
	$(WAF) uninstall

test:
	$(WAF) test $(TEST_OPTIONS)

dist:
	$(WAF) dist

distcheck:
	$(WAF) distcheck

clean:
	$(WAF) clean

distclean:
	$(WAF) distclean

reconfigure: configure
	$(WAF) reconfigure

show_waf_options:
	$(WAF) --help

# some compatibility make targets
everything: all

testsuite: all

check: test

# this should do an install as well, once install is finished
installcheck: test

etags:
	$(WAF) etags

ctags:
	$(WAF) ctags

=== lib/tevent/wscript ===
#!/usr/bin/env python

APPNAME = 'tevent'
VERSION = '0.9.9'

blddir = 'bin'

import sys, os

# find the buildtools directory
srcdir = '.'
while not os.path.exists(srcdir+'/buildtools') and len(srcdir.split('/')) < 5:
    srcdir = '../' + srcdir
sys.path.insert(0, srcdir + '/buildtools/wafsamba')

import wafsamba, samba_dist, Options, Logs

samba_dist.DIST_DIRS('lib/tevent:. lib/replace:lib/replace lib/talloc:lib/talloc buildtools:buildtools')

def set_options(opt):
    opt.BUILTIN_DEFAULT('replace')
    opt.BUNDLED_EXTENSION_DEFAULT('tevent', noextension='tevent')
    opt.RECURSE('lib/replace')
    opt.RECURSE('lib/talloc')
    if opt.IN_LAUNCH_DIR():
        opt.add_option('--disable-python',
                       help=("disable the pytevent module"),
                       action="store_true", dest='disable_python', default=False)


def configure(conf):
    conf.RECURSE('lib/replace')
    conf.RECURSE('lib/talloc')

    conf.env.standalone_tevent = conf.IN_LAUNCH_DIR()

    if not conf.env.standalone_tevent:
        if conf.CHECK_BUNDLED_SYSTEM('tevent', minversion=VERSION,
                                     onlyif='talloc', implied_deps='replace talloc'):
            conf.define('USING_SYSTEM_TEVENT', 1)

    if conf.CHECK_FUNCS('epoll_create', headers='sys/epoll.h'):
        conf.DEFINE('HAVE_EPOLL', 1)

    conf.env.disable_python = getattr(Options.options, 'disable_python', False)

    if not conf.env.disable_python:
        # also disable if we don't have the python libs installed
        conf.check_tool('python')
        conf.check_python_version((2,4,2))
        conf.check_python_headers(mandatory=False)
        if not conf.env.HAVE_PYTHON_H:
            Logs.warn('Disabling pytevent as python devel libs not found')
            conf.env.disable_python = True

    conf.SAMBA_CONFIG_H()

def build(bld):
    bld.RECURSE('lib/replace')
    bld.RECURSE('lib/talloc')

    SRC = '''tevent.c tevent_debug.c tevent_fd.c tevent_immediate.c
             tevent_queue.c tevent_req.c tevent_select.c
             tevent_signal.c tevent_standard.c tevent_timed.c tevent_util.c tevent_wakeup.c'''

    if bld.CONFIG_SET('HAVE_EPOLL'):
        SRC += ' tevent_epoll.c'

    if not bld.CONFIG_SET('USING_SYSTEM_TEVENT'):
        bld.SAMBA_LIBRARY('tevent',
                          SRC,
                          deps='replace talloc',
                          enabled= not bld.CONFIG_SET('USING_SYSTEM_TEVENT'),
                          abi_file='ABI/tevent-%s.sigs' % VERSION,
                          abi_match='tevent_* _tevent_*',
                          vnum=VERSION, 
						  is_bundled=not bld.env.standalone_tevent)

    if bld.env.standalone_tevent:
        bld.env.PKGCONFIGDIR = '${LIBDIR}/pkgconfig'
        bld.PKG_CONFIG_FILES('tevent.pc', vnum=VERSION)
        bld.INSTALL_FILES('${INCLUDEDIR}', 'tevent.h')

    bld.SAMBA_PYTHON('pytevent',
                     'pytevent.c',
                     deps='tevent',
                     enabled=True,
                     realname='_tevent.so')


def test(ctx):
    '''test tevent'''
    print("The tevent testsuite is part of smbtorture in samba4")


def dist():
    '''makes a tarball for distribution'''
    samba_dist.dist()

=== lib/uid_wrapper/wscript ===
#!/usr/bin/env python

import Options

def set_options(opt):
	gr = opt.option_group('developer options')
        gr.add_option('--enable-uid-wrapper',
                   help=("Turn on uid wrapper library (default=no)"),
                   action="store_true", dest='enable_uid_wrapper', default=False)

def configure(conf):
    if (Options.options.enable_uid_wrapper or
	Options.options.developer or
	Options.options.enable_selftest):
        conf.DEFINE('UID_WRAPPER', 1)

=== source4/selftest/wscript ===
#!/usr/bin/env python
# vim: expandtab ft=python

# selftest main code.

import Scripting, os, Options, Utils, Environment, optparse, sys
from samba_utils import *
from samba_autoconf import *

def set_options(opt):

    opt.add_option('--enable-selftest',
                   help=("enable options necessary for selftest (default=no)"),
                   action="store_true", dest='enable_selftest', default=False)
    opt.add_option('--with-selftest-prefix',
                   help=("specify location of selftest directory (default=./st)"),
                   action="store", dest='SELFTEST_PREFIX', default='./st')

    opt.ADD_COMMAND('test', cmd_test)
    opt.ADD_COMMAND('testonly', cmd_testonly)

    gr = opt.add_option_group('test options')

    gr.add_option('--load-list', 
                  help=("Load a test id list from a text file"),
                  action="store", dest='LOAD_LIST', default=None)
    gr.add_option('--tests',
                  help=("wildcard pattern of tests to run"),
                  action="store", dest='TESTS', default='')
    gr.add_option('--filtered-subunit',
                  help=("output (xfail) filtered subunit"),
                  action="store_true", dest='FILTERED_SUBUNIT', default=False)
    gr.add_option('--quick',
                  help=("enable only quick tests"),
                  action="store_true", dest='QUICKTEST', default=False)
    gr.add_option('--slow',
                  help=("enable the really slow tests"),
                  action="store_true", dest='SLOWTEST', default=False)
    gr.add_option('--testenv',
                  help=("start a terminal with the test environment setup"),
                  action="store_true", dest='TESTENV', default=False)
    gr.add_option('--valgrind',
                  help=("use valgrind on client programs in the tests"),
                  action="store_true", dest='VALGRIND', default=False)
    gr.add_option('--valgrind-log',
                  help=("where to put the valgrind log"),
                  action="store", dest='VALGRINDLOG', default=None)
    gr.add_option('--valgrind-server',
                  help=("use valgrind on the server in the tests (opens an xterm)"),
                  action="store_true", dest='VALGRIND_SERVER', default=False)
    gr.add_option('--gdbtest',
                  help=("run the testsuite within a gdb xterm window"),
                  action="store_true", dest='GDBTEST', default=False)
    gr.add_option('--fail-immediately',
                  help=("stop tests on first failure"),
                  action="store_true", dest='FAIL_IMMEDIATELY', default=False)
    gr.add_option('--socket-wrapper-pcap',
                  help=("create a pcap file for each failing test"),
                  action="store_true", dest='SOCKET_WRAPPER_PCAP', default=False)
    gr.add_option('--socket-wrapper-keep-pcap',
                  help=("create a pcap file for all individual test"),
                  action="store_true", dest='SOCKET_WRAPPER_KEEP_PCAP', default=False)

def configure(conf):
    conf.env.SELFTEST_PREFIX = Options.options.SELFTEST_PREFIX

def cmd_testonly(opt):
    '''run tests without doing a build first'''
    env = LOAD_ENVIRONMENT()
    opt.env = env

    if (not CONFIG_SET(opt, 'NSS_WRAPPER') or
        not CONFIG_SET(opt, 'UID_WRAPPER') or
        not CONFIG_SET(opt, 'SOCKET_WRAPPER')):
        print("ERROR: You must use --enable-selftest to enable selftest")
        sys.exit(1)

    env.TESTS  = Options.options.TESTS

    env.SUBUNIT_FORMATTER = '${PYTHON} -u ../selftest/format-subunit --prefix=${SELFTEST_PREFIX} --immediate'
    env.FILTER_XFAIL = '${PYTHON} -u ../selftest/filter-subunit --expected-failures=./selftest/knownfail'

    if Options.options.FAIL_IMMEDIATELY:
        env.FILTER_XFAIL += ' --fail-immediately'

    env.FORMAT_TEST_OUTPUT = '${SUBUNIT_FORMATTER}'

    env.OPTIONS = ''
    if not Options.options.SLOWTEST:
        env.OPTIONS += ' --exclude=./selftest/slow'
    if Options.options.QUICKTEST:
        env.OPTIONS += ' --quick --include=./selftest/quick'
    if Options.options.LOAD_LIST:
        env.OPTIONS += ' --load-list=%s' % Options.options.LOAD_LIST
    if Options.options.TESTENV:
        env.OPTIONS += ' --testenv'
    if Options.options.SOCKET_WRAPPER_PCAP:
        env.OPTIONS += ' --socket-wrapper-pcap'
    if Options.options.SOCKET_WRAPPER_KEEP_PCAP:
        env.OPTIONS += ' --socket-wrapper-keep-pcap'

    if os.environ.get('RUN_FROM_BUILD_FARM') is not None:
        env.FILTER_OPTIONS = '${FILTER_XFAIL} --strip-passed-output'
    else:
        env.FILTER_OPTIONS = '${FILTER_XFAIL}'

    if Options.options.VALGRIND:
        os.environ['VALGRIND'] = 'valgrind -q --num-callers=30'
        if Options.options.VALGRINDLOG is not None:
            os.environ['VALGRIND'] += ' --log-file=%s' % Options.options.VALGRINDLOG

    if Options.options.VALGRIND_SERVER:
        os.environ['SAMBA_VALGRIND'] = 'xterm -n server -l -e ../selftest/valgrind_run DUMMY=X'

    if Options.options.GDBTEST:
        os.environ['SAMBA_VALGRIND'] = 'xterm -n server -e ../selftest/gdb_run DUMMY=X'

    # this is needed for systems without rpath, or with rpath disabled
    ADD_LD_LIBRARY_PATH('bin/shared')

    # tell build system where to find config.h
    os.environ['CONFIG_H'] = 'bin/default/source4/include/config.h'

    st_done = os.path.join(env.SELFTEST_PREFIX, 'st_done')
    if os.path.exists(st_done):
        os.unlink(st_done)

    cmd = '(${PERL} ../selftest/selftest.pl --prefix=${SELFTEST_PREFIX} --builddir=. --srcdir=. --exclude=./selftest/skip --testlist="./selftest/tests.sh|" ${OPTIONS} --socket-wrapper ${TESTS} && touch ${SELFTEST_PREFIX}/st_done) | ${FILTER_OPTIONS} | tee ${SELFTEST_PREFIX}/subunit'
    if os.environ.get('RUN_FROM_BUILD_FARM') is None and not Options.options.FILTERED_SUBUNIT:
        cmd += ' | ${FORMAT_TEST_OUTPUT}'
    cmd = EXPAND_VARIABLES(opt, cmd)

    print("test: running %s" % cmd)
    ret = RUN_COMMAND(cmd, env=env)
    if os.path.exists(".testrepository"):
        # "testr load -q" isn't
        cmd = 'testr load -q < ${SELFTEST_PREFIX}/subunit > /dev/null'
        cmd = EXPAND_VARIABLES(opt, cmd)
        RUN_COMMAND(cmd, env=env)

    if ret != 0:
        print("ERROR: test failed with exit code %d" % ret)
        sys.exit(ret)

    if not os.path.exists(st_done):
        print("ERROR: test command failed to complete")
        sys.exit(1)


########################################################################
# main test entry point
def cmd_test(opt):
    '''Run the test suite (see test options below)'''
    Scripting.commands.append('build')
    Scripting.commands.append('testonly')

=== lib/subunit/c/wscript ===
#!/usr/bin/env python

import Options

def configure(conf):
	if conf.CHECK_BUNDLED_SYSTEM('subunit', checkfunctions='subunit_test_start', headers='subunit/child.h'):
		conf.define('USING_SYSTEM_SUBUNIT', 1)

def build(bld):
	if bld.CONFIG_SET('USING_SYSTEM_SUBUNIT'):
		return

	bld.SAMBA_LIBRARY('subunit', source='lib/child.c', is_bundled=True,
			includes='include')

=== debian/changelog ===
samba4 (4.0.0~alpha14~bzr13684.dfsg1-1build1) natty; urgency=low

  * Rebuild with python 2.7 as the python default.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 08 Dec 2010 15:10:18 +0000

samba4 (4.0.0~alpha14~bzr13684.dfsg1-1) unstable; urgency=low

  * New upstream snapshot.
   + Depend on libsubunit-dev.
  * Support talloc 2.0.1.
  * Update dependency for ldb to be >= 0.9.14. Closes: #596745
  * Support parallel builds.

 -- Jelmer Vernooij <jelmer@debian.org>  Tue, 28 Sep 2010 09:46:54 +0200

=== debian/control ===
Source: samba4
Section: net
Priority: optional
Maintainer: Samba Debian Maintainers <pkg-samba-maint@lists.alioth.debian.org>
Uploaders: Steve Langasek <vorlon@debian.org>, Christian Perrier <bubulle@debian.org>, Noèl Köthe <noel@debian.org>, Steinar H. Gunderson <sesse@debian.org>, Jelmer Vernooij <jelmer@debian.org>
Homepage: http://www.samba.org/
Standards-Version: 3.9.1
Build-Depends: debhelper (>> 5.0.0), libparse-yapp-perl, perl, docbook-xsl, docbook-xml, xsltproc, po-debconf, libgnutls-dev, libreadline5-dev, libpam0g-dev, libblkid-dev, libattr1-dev, flex, bison, libtdb-dev (>= 1.2.1~), libtalloc-dev (>= 2.0.1~), libtevent-dev (>= 0.9.9~), perl-modules, python-dev, python-central (>= 0.5.6), libpopt-dev, pkg-config, samba-common (>= 2:3.4.0~pre2), libldb-dev (>= 1:0.9.14~), python-ldb, python-tdb, zlib1g-dev (>= 1:1.2.3), heimdal-multidev (>= 1.4~), python-dnspython, python-testtools, subunit (>= 0.0.6), libsubunit-dev
Vcs-Browser: http://bzr.debian.org/lh/pkg-samba/samba4/unstable
Vcs-Bzr: http://bzr.debian.org/pkg-samba/samba4/unstable
XS-Python-Version: current
DM-Upload-Allowed: yes

Package: samba4
Architecture: any
Recommends: samba-ldb-tools
Suggests: bind9 (>= 1:9.5.1), phpldapadmin, swat2
Conflicts: samba-tools, samba (<< 2:3.3.0~rc2-5)
Depends: ${shlibs:Depends}, ${misc:Depends}, samba4-common-bin (=${source:Version}), python, python-samba, ${python:Depends}, python-dnspython
XB-Python-Version: ${python:Versions}
Description: SMB/CIFS file, print and logon server (version 4)
 The Samba software suite is a collection of programs that
 implements the SMB protocol for unix systems, allowing you to serve
 files to Windows, NT, OS/2 and DOS clients, as well as
 run as a domain controller for Active Directory.
 .
 These packages contain snapshot versions of Samba 4, the next-generation
 version of Samba. These should be considered _experimental_, and should
 not be used in production.
 .
 This package contains smbd, the Samba file, print and domain server.

Package: samba4-common-bin
Architecture: all
Depends: ${misc:Depends}, samba-common (>= 2:3.4.0~pre2-1), ${python:Depends}
Conflicts: samba (<< 2:3.3.0~rc2-5), samba-common (<< 2:3.3.0~rc2-5)
Replaces: samba4-common (<< 2:3.4.0~pre2-1), samba4-common (<< 4.0.0~alpha7-1)
XB-Python-Version: ${python:Versions}
Description: Samba 4 common files used by both the server and the client
 The Samba software suite is a collection of programs that
 implements the SMB/CIFS protocol for unix systems, allowing you to serve
 files to Windows, NT, OS/2 and DOS clients. This protocol
 is sometimes also referred to as the LanManager or NetBIOS protocol.
 .
 These packages contain snapshot versions of Samba 4, the next-generation
 version of Samba. These should be considered _experimental_, and should
 not be used in production.
 .
 This package contains the common files that are used by both the server
 (provided in the samba package) and the client (provided in the samba-clients
 package).

Package: samba4-clients
Architecture: any
Depends: ${shlibs:Depends}, samba4-common-bin (=${source:Version}), ${misc:Depends}
Conflicts: smbclient, samba-common (<< 2:3.3.0~rc2-5)
XB-Python-Version: ${python:Versions}
Provides: smbclient
Description: client utilities from Samba 4
 The Samba software suite is a collection of programs that
 implements the SMB protocol for unix systems, allowing you to serve
 files to Windows, NT, OS/2 and DOS clients. This protocol
 is sometimes also referred to as the LanManager or NetBIOS protocol.
 .
 These packages contain snapshot versions of Samba 4, the next-generation
 version of Samba.
 .
 This package contains some client components of the Samba suite. In
 particular it includes the command line utilities smbclient, net,
 and some ACL tools.

Package: samba4-testsuite
Architecture: any
Conflicts: samba-tools
Recommends: subunit
Depends: ${shlibs:Depends}, samba4-common-bin, ${misc:Depends}
XB-Python-Version: ${python:Versions}
Description: test suite from Samba 4
 The Samba software suite is a collection of programs that
 implements the SMB protocol for unix systems, allowing you to serve
 files to Windows, NT, OS/2 and DOS clients, as well as
 run as a domain controller for Active Directory.
 .
 This package contains programs for testing the reliability and speed
 of SMB servers, Samba in particular.

Package: registry-tools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
XB-Python-Version: ${python:Versions}
Description: tools for viewing and manipulating the Windows registry
 The Samba software suite is a collection of programs that
 implements the SMB protocol for unix systems, allowing you to serve
 files to Windows, NT, OS/2 and DOS clients, as well as
 run as a domain controller for Active Directory.
 .
 These packages contain snapshot versions of Samba 4, the next-generation
 version of Samba. These should be considered _experimental_, and should
 not be used in production.
 .
 This package contains tools for viewing and manipulating the binary
 "registry" found on Windows machines, both locally and remote.

Package: libparse-pidl-perl
Architecture: any
Depends: ${perl:Depends}, libparse-yapp-perl, ${misc:Depends}
Recommends: libdcerpc-dev
Section: perl
XB-Python-Version: ${python:Versions}
Description: IDL compiler written in Perl
 The Samba software suite is a collection of programs that
 implements the SMB protocol for unix systems, allowing you to serve
 files to Windows, NT, OS/2 and DOS clients, as well as
 run as a domain controller for Active Directory.
 .
 This package contains the IDL (Interface Description Language) compiler pidl,
 which takes in IDL files and can output C code for various uses. It is
 primarily of interest to developers.

Package: samba4-dev
Architecture: any
Depends: libparse-pidl-perl, libc6-dev, libldb-dev, libtdb-dev (>= 1.1.0), libtalloc-dev, ${misc:Depends}
Section: devel
XB-Python-Version: ${python:Versions}
Description: tools for extending Samba
 The Samba software suite is a collection of programs that
 implements the SMB protocol for unix systems, allowing you to serve
 files to Windows, NT, OS/2 and DOS clients, as well as
 run as a domain controller for Active Directory.
 .
 These packages contain snapshot versions of Samba 4, the next-generation
 version of Samba. These should be considered _experimental_, and should
 not be used in production.
 .
 This package contains include files shared by the various Samba-based
 libraries.

Package: samba-ldb-tools
Section: utils
Architecture: any
Provides: ldb-tools
Conflicts: ldb-tools
Depends: ${shlibs:Depends}, ${misc:Depends}
XB-Python-Version: ${python:Versions}
Description: LDAP-like embedded database - tools
 ldb is a LDAP-like embedded database built on top of TDB.
 .
 What ldb does is provide a fast database with an LDAP-like API designed
 to be used within an application. In some ways it can be seen as a
 intermediate solution between key-value pair databases and a real LDAP
 database.
 .
 This package contains bundled test and utility binaries built specifically
 for Samba.

Package: libgensec0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, samba-common (>= 2:3.4.0~pre2-1)
XB-Python-Version: ${python:Versions}
Description: Generic Security Library
 The Samba software suite is a collection of programs that
 implements the SMB protocol for unix systems, allowing you to serve
 files to Windows, NT, OS/2 and DOS clients, as well as
 run as a domain controller for Active Directory.
 .
 These packages contain snapshot versions of Samba 4, the next-generation
 version of Samba.
 .
 This library provides a generalized API for several security protocols.

Package: libgensec-dev
Architecture: any
Section: libdevel
Depends: libgensec0 (=${binary:Version}), pkg-config, ${misc:Depends}
XB-Python-Version: ${python:Versions}
Description: Generic Security Library
 The Samba software suite is a collection of programs that
 implements the SMB protocol for unix systems, allowing you to serve
 files to Windows, NT, OS/2 and DOS clients, as well as
 run as a domain controller for Active Directory.
 .
 These packages contain snapshot versions of Samba 4, the next-generation
 version of Samba.
 .
 This library provides a generalized API for several security protocols.
 .
 This package contains the files required for development.

Package: libndr0
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
XB-Python-Version: ${python:Versions}
Description: NDR marshalling library
 The Samba software suite is a collection of programs that
 implements the SMB protocol for unix systems, allowing you to serve
 files to Windows, NT, OS/2 and DOS clients, as well as
 run as a domain controller for Active Directory.
 .
 This package contains the library for encoding and decoding data structures
 using the Network Data Representation format as used by DCE/RPC.

Package: libndr-dev
Architecture: any
Section: libdevel
Depends: libndr0 (=${binary:Version}), pkg-config, ${misc:Depends}
XB-Python-Version: ${python:Versions}
Description: NDR marshalling library - development files
 The Samba software suite is a collection of programs that
 implements the SMB protocol for unix systems, allowing you to serve
 files to Windows, NT, OS/2 and DOS clients, as well as
 run as a domain controller for Active Directory.
 .
 This package contains the library for encoding and decoding data structures
 using the Network Data Representation format as used by DCE/RPC.
 .
 This package contains the files required for development.

Package: libndr-standard0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
XB-Python-Version: ${python:Versions}
Description: Standard NDR interfaces
 The Samba software suite is a collection of programs that
 implements the SMB protocol for unix systems, allowing you to serve
 files to Windows, NT, OS/2 and DOS clients, as well as
 run as a domain controller for Active Directory.
 .
 This package contains NDR encoders/decoders for the set of standard
 DCE/RPC interfaces found on Windows and Samba servers.

Package: libndr-standard-dev
Architecture: any
Section: libdevel
Depends: libndr-standard0 (=${binary:Version}), pkg-config, ${misc:Depends}
XB-Python-Version: ${python:Versions}
Description: Standard NDR interfaces - development files
 The Samba software suite is a collection of programs that
 implements the SMB protocol for unix systems, allowing you to serve
 files to Windows, NT, OS/2 and DOS clients, as well as
 run as a domain controller for Active Directory.
 .
 This package contains NDR encoders/decoders for the set of standard
 DCE/RPC interfaces found on Windows and Samba servers.
 .
 This package contains the files required for development.

Package: libdcerpc0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
XB-Python-Version: ${python:Versions}
Description: DCE/RPC client library
 The Samba software suite is a collection of programs that
 implements the SMB protocol for unix systems, allowing you to serve
 files to Windows, NT, OS/2 and DOS clients, as well as
 run as a domain controller for Active Directory.
 .
 These packages contain snapshot versions of Samba 4, the next-generation
 version of Samba.
 .
 Client-side implementation of the DCE/RPC protocol.
 Support for the following transports is provided:
  - ncacn_np
  - ncacn_ip_tcp
  - ncalrpc
  - ncacn_sock_unix

Package: libdcerpc-dev
Architecture: any
Section: libdevel
Depends: libdcerpc0 (=${binary:Version}), libndr-dev, pkg-config, ${misc:Depends}, libsamba-util-dev
XB-Python-Version: ${python:Versions}
Description: DCE/RPC library
 The Samba software suite is a collection of programs that
 implements the SMB protocol for unix systems, allowing you to serve
 files to Windows, NT, OS/2 and DOS clients, as well as
 run as a domain controller for Active Directory.
 .
 These packages contain snapshot versions of Samba 4, the next-generation
 version of Samba.
 .

=== debian/watch ===
version=2
opts="uversionmangle=s/tp/~alpha1~tp/;s/alpha/~alpha/,dversionmangle=s/\\.dfsg\\.\\d+$//" \
	  ftp://ftp.samba.org/pub/samba/samba4/samba-(.*).tar.gz
